/*
 * Created on 24-07-2004
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package net.sf.l2j.gameserver;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.LineNumberReader;
import java.util.HashMap;
import java.util.StringTokenizer;
import java.util.logging.Logger;

import net.sf.l2j.gameserver.model.L2Modifiers;
/**
 * @author Nightmare
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class Modifiers
{
	private static Logger _log = Logger.getLogger(Modifiers.class.getName());
	
	private static Modifiers _instance;
	
	private HashMap _modifiers;
	
	public static Modifiers getInstance()
	{
		if (_instance == null)
		{
			_instance = new Modifiers();
		}
		return _instance;
	}
	
	private Modifiers()
	{
		_modifiers = new HashMap();
		LineNumberReader lnr = null;
		try
		{
			File ModifierData = new File("data/modifiers.csv");
			lnr = new LineNumberReader(new BufferedReader( new FileReader(ModifierData)));
			
			String line = null;
			while ( (line=lnr.readLine()) != null)
			{
				if (line.trim().length() == 0 || line.startsWith("#"))
				{
					continue;
				}

				L2Modifiers modif = parseList(line);
				_modifiers.put(new Integer(modif.getClassid()), modif);
			}

			_log.config("created " + _modifiers.size() + " Character Modifiers");
		}
		catch (FileNotFoundException e)
		{
			_log.warning("modifiers.csv is missing in data folder");
		}
		catch (Exception e)
		{
			_log.warning("error while creating character modifier table "+e);
		}
		finally
		{
			try
			{
				lnr.close();
			}
			catch (Exception e1)
			{
				// ignore problems
			}
		}
	}
	
	private L2Modifiers parseList(String line)
	{
		StringTokenizer st = new StringTokenizer(line,";");

		L2Modifiers modifier = new L2Modifiers();

		modifier.setClassid( Integer.parseInt(st.nextToken()) );
		modifier.setModstr( Integer.parseInt(st.nextToken()) );
		modifier.setModcon( Integer.parseInt(st.nextToken()) );
		modifier.setModdex( Integer.parseInt(st.nextToken()) );
		modifier.setModint( Integer.parseInt(st.nextToken()) );
		modifier.setModmen( Integer.parseInt(st.nextToken()) );
		modifier.setModwit( Integer.parseInt(st.nextToken()) );
		
		return modifier;
	}

	/**
	 * @param template id
	 * @return
	 */
	public L2Modifiers getTemplate(int id)
	{
		return (L2Modifiers) _modifiers.get(new Integer(id));
	}
}
