/*
 * $Header: /var/lib/gforge/chroot/cvsroot/nextg/CVSROOT/L2_Gameserver/java/net/sf/l2j/gameserver/NpcDataTable.java,v 1.3 2004/08/05 00:53:40 nextg Exp $
 *
 * $Author: nextg $
 * $Date: 2004/08/05 00:53:40 $
 * $Revision: 1.3 $
 * $Log: NpcDataTable.java,v $
 * Revision 1.3  2004/08/05 00:53:40  nextg
 * RuSh
 *
 * Revision 1.5  2004/07/23 21:28:59  l2chef
 * renamed method
 *
 * Revision 1.4  2004/07/23 01:49:48  l2chef
 * some additional colums were added to npc data
 *
 * Revision 1.2  2004/07/13 23:14:52  l2chef
 * empty blocks commented
 *
 * Revision 1.1  2004/07/11 11:45:14  l2chef
 * new table parser ... (NightMarez)
 *
 * Revision 1.1  2004/07/08 22:20:00  l2chef
 * teleporter npcs added by NightMarez
 *
 * Revision 1.1  2004/07/09 22:09:51  NightMarez.
 * Initial release
 * 
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 *
 * http://www.gnu.org/copyleft/gpl.html
 */
package net.sf.l2j.gameserver;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.LineNumberReader;
import java.util.HashMap;
import java.util.StringTokenizer;
import java.util.logging.Logger;

import net.sf.l2j.gameserver.model.L2NpcData;

/**
 * This class ...
 *
 * @version $Revision: 1.3 $ $Date: 2004/08/05 00:53:40 $
 */
public class NpcDataTable
{
	private static Logger _log = Logger.getLogger(NpcDataTable.class.getName());
	
	private static NpcDataTable _instance;
	
	private HashMap _datatable;
	
	public static NpcDataTable getInstance()
	{
		if (_instance == null)
		{
			_instance = new NpcDataTable();
		}
		return _instance;
	}
	
	private NpcDataTable()
	{
		_datatable = new HashMap();
		LineNumberReader lnr = null;
		try
		{
			File npcDataFile = new File("data/npc2.csv");
			lnr = new LineNumberReader(new BufferedReader( new FileReader(npcDataFile)));
			
			String line = null;
			while ( (line=lnr.readLine()) != null)
			{
				if (line.trim().length() == 0 || line.startsWith("#"))
				{
					continue;
				}

				try
				{
					L2NpcData npcData = parseList(line);
					_datatable.put(new Integer(npcData.getId()), npcData);
				}
				catch (Exception e)
				{
					_log.warning("parsing error in npc2.csv, line " + lnr.getLineNumber() +" / " + e.toString());
				}
			}

			_log.config("created " + _datatable.size() + " NPC data templates");
		}
		catch (FileNotFoundException e)
		{
			_log.warning("npc2.csv is missing in data folder");
		}
		catch (Exception e)
		{
			_log.warning("error while creating npc data table "+e);
		}
		finally
		{
			try
			{
				lnr.close();
			}
			catch (Exception e1)
			{
				// ignore problems
			}
		}
	}

	private L2NpcData parseList(String line)
	{
		StringTokenizer st = new StringTokenizer(line,";");

		L2NpcData npcDat = new L2NpcData();
		npcDat.setId(Integer.parseInt(st.nextToken()) );
		npcDat.setName( st.nextToken() );
		npcDat.setLevel(Integer.parseInt(st.nextToken()) );
		npcDat.setSex( st.nextToken() );
		npcDat.setNpcType( st.nextToken() );
		npcDat.setAttackrange(Integer.parseInt(st.nextToken()) );
		npcDat.setHp(Integer.parseInt(st.nextToken()) );
		npcDat.setMp(Integer.parseInt(st.nextToken()) );
		npcDat.setExp(Integer.parseInt(st.nextToken()) );
		npcDat.setSp(Integer.parseInt(st.nextToken()) );
		npcDat.setPatk(Integer.parseInt(st.nextToken()) );
		npcDat.setPdef(Integer.parseInt(st.nextToken()) );
		npcDat.setMatk(Integer.parseInt(st.nextToken()) );
		npcDat.setMdef(Integer.parseInt(st.nextToken()) );
		npcDat.setAtkspd(Integer.parseInt(st.nextToken()) );
		npcDat.setAgro(Integer.parseInt(st.nextToken()) );
		npcDat.setMatkspd(Integer.parseInt(st.nextToken()) );
		npcDat.setRhand(Integer.parseInt(st.nextToken()));
		npcDat.setLhand(Integer.parseInt(st.nextToken()));
		npcDat.setArmor(Integer.parseInt(st.nextToken()));
		npcDat.setWalkspd(Integer.parseInt(st.nextToken()));
		npcDat.setRunspd(Integer.parseInt(st.nextToken()));
		
		return npcDat;
	}
	
	/**
	 * @param template id
	 * @return
	 */
	public L2NpcData getTemplate(int id)
	{
		return (L2NpcData) _datatable.get(new Integer(id));
	}
}
