/*
 * $Header: /var/lib/gforge/chroot/cvsroot/nextg/CVSROOT/L2_Gameserver/java/net/sf/l2j/gameserver/clientpackets/RequestAnswerJoinParty.java,v 1.3 2004/08/05 00:53:40 nextg Exp $
 *
 * $Author: nextg $
 * $Date: 2004/08/05 00:53:40 $
 * $Revision: 1.3 $
 * $Log: RequestAnswerJoinParty.java,v $
 * Revision 1.3  2004/08/05 00:53:40  nextg
 * RuSh
 *
 * Revision 1.3  2004/07/19 02:01:35  l2chef
 * party code completed (whatev)
 *
 * Revision 1.2  2004/07/04 19:09:47  l2chef
 * party window is updated
 *
 * Revision 1.1  2004/07/04 11:12:18  l2chef
 * new party related handers
 *
 * Revision 1.2  2004/06/27 08:51:42  jeichhorn
 * Added copyright notice
 *
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 *
 * http://www.gnu.org/copyleft/gpl.html
 */
package net.sf.l2j.gameserver.clientpackets;

import java.util.logging.Logger;

import net.sf.l2j.gameserver.ClientThread;
import net.sf.l2j.gameserver.model.L2PcInstance;
import net.sf.l2j.gameserver.serverpackets.JoinParty;
import net.sf.l2j.gameserver.serverpackets.PartySmallWindowAll;
import net.sf.l2j.gameserver.serverpackets.SystemMessage;
import net.sf.l2j.gameserver.serverpackets.PartySmallWindowAdd;
import java.util.ArrayList;

/**
 *  sample
 *  2a 
 *  01 00 00 00
 * 
 *  format  cdd
 * 
 * 
 * @version $Revision: 1.3 $ $Date: 2004/08/05 00:53:40 $
 */
public class RequestAnswerJoinParty extends ClientBasePacket
{
	private static final String _C__2A_REQUESTANSWERPARTY = "[C] 2A RequestAnswerParty";
	private static Logger _log = Logger.getLogger(RequestAnswerJoinParty.class.getName());
	
	public RequestAnswerJoinParty(byte[] decrypt, ClientThread client)
	{
		super(decrypt);
		int response = readD();
		
		L2PcInstance player = client.getActiveChar();
		//clears out their requestor flags
		L2PcInstance requestor = player.getPartyInviter();
		requestor.getPartyInviter();
		
		JoinParty join = new JoinParty(response);
		requestor.sendPacket(join);	
		PartySmallWindowAll window = new PartySmallWindowAll();
		ArrayList partyMembers = requestor.getPartyMembers();
		L2PcInstance temp;
		
			
		if (response == 1)
		{
				
			if (partyMembers == null )//new party starting
			{
				requestor.setPartyMembers(new ArrayList());
				partyMembers = requestor.getPartyMembers();
				
				partyMembers.add(requestor);// first member of party is always index 0 of list;
				requestor.sendPacket(new PartySmallWindowAdd(player));
				requestor.addStatusListener(player);
				
				
				player.sendPacket(new PartySmallWindowAdd(requestor));
				partyMembers.add(player);
				player.setPartyMembers(partyMembers);
				player.addStatusListener(requestor);
								
				//sends them their system messages
				SystemMessage msg = new SystemMessage(SystemMessage.YOU_JOINED_S1_PARTY);
				msg.addString(requestor.getName());
				player.sendPacket(msg);
				msg = new SystemMessage(SystemMessage.S1_JOINED_PARTY);
				msg.addString(player.getName());
				requestor.sendPacket(msg);
			}
			else//adding people to a party already formed
			{
				//sends new member party window for all members
				window.setPartyList(partyMembers);
				player.sendPacket(window);
				SystemMessage msg = new SystemMessage(SystemMessage.YOU_JOINED_S1_PARTY);
				msg.addString(requestor.getName());
				player.sendPacket(msg);
				
				//tell everyone and adds the player to party 
				msg = new SystemMessage(SystemMessage.S1_JOINED_PARTY);
				msg.addString(player.getName());
				for (int x = 0; x < partyMembers.size(); x++)
				{
					temp = (L2PcInstance)partyMembers.get(x);
					temp.sendPacket(new PartySmallWindowAdd(player));
					temp.sendPacket(msg);
				}
				
				partyMembers.add(player);
				player.setPartyMembers(partyMembers);
			}
		}
		else
		{
			SystemMessage msg = new SystemMessage(SystemMessage.PLAYER_DECLINED);
			requestor.sendPacket(msg);
		}
	}

	/* (non-Javadoc)
	 * @see net.sf.l2j.gameserver.clientpackets.ClientBasePacket#getType()
	 */
	public String getType()
	{
		return _C__2A_REQUESTANSWERPARTY;
	}
}
