
package net.sf.l2j.gameserver.clientpackets;

import java.io.IOException;
import java.util.logging.Logger;

import net.sf.l2j.gameserver.ClientThread;
import net.sf.l2j.gameserver.ItemTable;
import net.sf.l2j.gameserver.model.L2ItemInstance;
import net.sf.l2j.gameserver.model.L2World;
import net.sf.l2j.gameserver.serverpackets.InventoryUpdate;
//import net.sf.l2j.gameserver.serverpackets.PetInventoryUpdate;
import net.sf.l2j.gameserver.serverpackets.PetItemList;

public class RequestGiveItemToPet extends ClientBasePacket {
	private static final String REQUESTGETITEMFROMPET__C__8C = "[C] 8C RequestGetItemFromPet";
	private static Logger _log = Logger.getLogger(RequestGetItemFromPet.class.getName());
	
	public RequestGiveItemToPet (byte[] decrypt, ClientThread client) throws IOException
	{
		super(decrypt);
		int itemId = readD();
		int Amount = readD();
		
		
		L2World world = L2World.getInstance();
		L2ItemInstance itemtemp = (L2ItemInstance)world.findObject(itemId);
		PetItemList petiu = new PetItemList(client.getActiveChar().getPet());
		InventoryUpdate PlayerUI = new InventoryUpdate();
		
		if (Amount >= itemtemp.getCount())
		{
			
				client.getActiveChar().getPet().getInventory().addItem(itemtemp);
				client.getActiveChar().getInventory().getItems().remove(itemtemp);
				PlayerUI.addRemovedItem(itemtemp);
				
				client.getActiveChar().sendPacket(PlayerUI);
				client.getActiveChar().sendPacket(petiu);
			
		}
		else
		{
			int total = itemtemp.getCount();
			L2ItemInstance newitem = ItemTable.getInstance().createItem(itemtemp.getItemId());
			//deal with pet
			newitem.setCount(Amount);
			client.getActiveChar().getPet().getInventory().addItem(newitem);
			//deal with player
			itemtemp.setCount(total-Amount);
			PlayerUI.addModifiedItem(itemtemp);
			//send updates
			client.getActiveChar().sendPacket(petiu);
			client.getActiveChar().sendPacket(PlayerUI);
		}
		
				
		
		
		
		
	} 
	
	public String getType()
	{
		return REQUESTGETITEMFROMPET__C__8C;
	}
}
