/*
 * $Header: /var/lib/gforge/chroot/cvsroot/nextg/CVSROOT/L2_Gameserver/java/net/sf/l2j/gameserver/clientpackets/RequestJoinParty.java,v 1.3 2004/08/05 00:53:40 nextg Exp $
 *
 * $Author: nextg $
 * $Date: 2004/08/05 00:53:40 $
 * $Revision: 1.3 $
 * $Log: RequestJoinParty.java,v $
 * Revision 1.3  2004/08/05 00:53:40  nextg
 * RuSh
 *
 * Revision 1.2  2004/07/19 02:01:35  l2chef
 * party code completed (whatev)
 *
 * Revision 1.1  2004/07/04 11:09:46  l2chef
 * new party related handers
 *
 * Revision 1.2  2004/06/27 08:51:42  jeichhorn
 * Added copyright notice
 *
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 *
 * http://www.gnu.org/copyleft/gpl.html
 */
package net.sf.l2j.gameserver.clientpackets;

import java.util.logging.Logger;

import net.sf.l2j.gameserver.ClientThread;
import net.sf.l2j.gameserver.model.L2PcInstance;
import net.sf.l2j.gameserver.model.L2World;
import net.sf.l2j.gameserver.serverpackets.AskJoinParty;
import net.sf.l2j.gameserver.serverpackets.SystemMessage;

/**
 *  sample
 *  29 
 *  42 00 00 10 
 *  01 00 00 00
 * 
 *  format  cdd
 * 
 * 
 * @version $Revision: 1.3 $ $Date: 2004/08/05 00:53:40 $
 */
public class RequestJoinParty extends ClientBasePacket
{
	private static final String _C__29_REQUESTJOINPARTY = "[C] 29 RequestJoinParty";
	private static Logger _log = Logger.getLogger(RequestJoinParty.class.getName());
	
	public RequestJoinParty(byte[] decrypt, ClientThread client)
	{
		super(decrypt);
		int id = readD();
		int itemDistribution = readD();
		
		SystemMessage msg;
		L2PcInstance target = (L2PcInstance) L2World.getInstance().findObject(id);
		L2PcInstance requestor = client.getActiveChar();
		
		
		if (client.getActiveChar().getPartyMembers() == null)//asker has no party
		{
			if(target.getKnownPlayers().contains( requestor ) && target.getPartyMembers() == null)
			{
				if (target.setPendingJoinPartyRequest( requestor )&& requestor.setPendingJoinPartyRequest(target))
				{
					AskJoinParty ask = new AskJoinParty( requestor.getObjectId(), itemDistribution);
					target.sendPacket(ask);
					_log.fine("sent out a party invitation to:"+target.getName());
					
				}
				else
				{
					// dunno if this is the right message, well it kinda makes sense
					// other party is frozen .. wait a while
					msg = new SystemMessage(692);
					requestor.sendPacket(msg);
					_log.warning( requestor.getName() + " already received a party invitation");
				}
				
			}
			else
			{
				if(target.getKnownPlayers().contains( requestor ))
				{
					_log.warning(client.getActiveChar().getName()+ " invited someone who doesn't know him.");
				}
				
				if(!(target.getPartyMembers() == null))
				{
					msg = new SystemMessage(SystemMessage.S1_IS_ALREADY_IN_PARTY);
					msg.addString(target.getName());
					requestor.sendPacket(msg);
				}
			}
		}
		else//asker has a party
		{
			if (target.getKnownPlayers().contains( requestor ) && target.getPartyMembers() == null && requestor.getPartyMembers().get(0) == requestor && requestor.getPartyMembers().size() < 9)
				
			{
				// only continue if the client actually knowns the id
				
				if (target.setPendingJoinPartyRequest( requestor ) && requestor.setPendingJoinPartyRequest(target))
				{
					AskJoinParty ask = new AskJoinParty( requestor.getObjectId(), itemDistribution);
					target.sendPacket(ask);
					_log.fine("sent out a party invitation to:"+target.getName());
					
				}
				else
				{
					// dunno if this is the right message, well it kinda makes sense
					// other party is frozen .. wait a while
					msg = new SystemMessage(692);
					requestor.sendPacket(msg);
					_log.warning( requestor.getName() + " already received a party invitation");
				}
			}
			else
			{
				if(requestor.getPartyMembers().size() >= 9)
				{
					msg = new SystemMessage(SystemMessage.PARTY_FULL);
					requestor.sendPacket(msg);
				}
				
				if(target.getKnownPlayers().contains( requestor ))
				{
					_log.warning(client.getActiveChar().getName()+ " invited someone who doesn't know him.");
				}
				
				if(!(target.getPartyMembers() == null))
				{
					msg = new SystemMessage(SystemMessage.S1_IS_ALREADY_IN_PARTY);
					msg.addString(target.getName());
					requestor.sendPacket(msg);
				}
				
				if(requestor.getPartyMembers().size() == 1)
				{
					msg = new SystemMessage(SystemMessage.S1_IS_ALREADY_IN_PARTY);
					msg.addString(target.getName());
					requestor.sendPacket(msg);
				}
				
			}
			
		}
	}
	
	/* (non-Javadoc)
	 * @see net.sf.l2j.gameserver.clientpackets.ClientBasePacket#getType()
	 */
	public String getType()
	{
		return _C__29_REQUESTJOINPARTY;
	}
}
