/*
 * $Header: /var/lib/gforge/chroot/cvsroot/nextg/CVSROOT/L2_Gameserver/java/net/sf/l2j/gameserver/clientpackets/RequestPledgeInfo.java,v 1.3 2004/08/05 00:53:40 nextg Exp $
 *
 * $Author: nextg $
 * $Date: 2004/08/05 00:53:40 $
 * $Revision: 1.3 $
 * $Log: RequestPledgeInfo.java,v $
 * Revision 1.3  2004/08/05 00:53:40  nextg
 * RuSh
 *
 * Revision 1.3  2004/07/04 11:12:33  l2chef
 * logging is used instead of system.out
 *
 * Revision 1.2  2004/06/27 08:51:42  jeichhorn
 * Added copyright notice
 *
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 *
 * http://www.gnu.org/copyleft/gpl.html
 */
package net.sf.l2j.gameserver.clientpackets;

import java.io.IOException;
import java.util.logging.Logger;

import net.sf.l2j.gameserver.ClanTable;
import net.sf.l2j.gameserver.ClientThread;
import net.sf.l2j.gameserver.model.L2Clan;
import net.sf.l2j.gameserver.model.L2PcInstance;
import net.sf.l2j.gameserver.serverpackets.PledgeInfo;
import net.sf.l2j.gameserver.serverpackets.PledgeShowMemberListAll;

/**
 * This class ...
 * 
 * @version $Revision: 1.3 $ $Date: 2004/08/05 00:53:40 $
 */
public class RequestPledgeInfo extends ClientBasePacket
{
	private static final String _C__66_REQUESTPLEDGEINFO = "[C] 66 RequestPledgeInfo";
	private static Logger _log = Logger.getLogger(RequestPledgeInfo.class.getName());
	
	/**
	 * packet type id 0x66
	 * format:		cd
	 * @param rawPacket
	 */
	public RequestPledgeInfo(byte[] rawPacket, ClientThread client) throws IOException
	{
		super(rawPacket);
		int clanId  = readD();
		
		_log.fine("infos for clan " + clanId + " requested");

		L2PcInstance activeChar = client.getActiveChar();
		L2Clan clan = ClanTable.getInstance().getClan(clanId);
		if (clan == null)
		{
			_log.warning("Clan data for clanId "+ clanId + " is missing");
			return; // we have no clan data ?!? should not happen
		}
			
		PledgeInfo pc = new PledgeInfo(clan);
		client.getConnection().sendPacket(pc);
		
		if (clan.getClanId() == activeChar.getClanId())
		{
			PledgeShowMemberListAll pm = new PledgeShowMemberListAll(clan, activeChar.getName());
			client.getConnection().sendPacket(pm);
		}
	}

	/* (non-Javadoc)
	 * @see net.sf.l2j.gameserver.clientpackets.ClientBasePacket#getType()
	 */
	public String getType()
	{
		return _C__66_REQUESTPLEDGEINFO;
	}
}
