
package net.sf.l2j.gameserver.clientpackets;
import java.util.ArrayList;
import java.util.logging.Logger;


import net.sf.l2j.gameserver.ClientThread;
import net.sf.l2j.gameserver.model.L2PcInstance;
import net.sf.l2j.gameserver.serverpackets.PartySmallWindowDeleteAll;
import net.sf.l2j.gameserver.serverpackets.PartySmallWindowDelete;
import net.sf.l2j.gameserver.serverpackets.SystemMessage;



public class RequestWithDrawalParty extends ClientBasePacket
{
	private static final String _C__2B_REQUESTWITHDRAWALPARTY = "[C] 2B RequestWithDrawalParty";
	private static Logger _log = Logger.getLogger(RequestWithDrawalParty.class.getName());
	
	public RequestWithDrawalParty(byte[] decrypt, ClientThread client)
	{	
		super(decrypt);
		L2PcInstance player = client.getActiveChar();
		ArrayList party = player.getPartyMembers();
		L2PcInstance temp;
		SystemMessage msg; 
		if (party != null)
		{
			if (party.get(0) == player)//this means that this is the partyleader
			{
				msg = new SystemMessage(SystemMessage.PARTY_DISPERSED);
				
				PartySmallWindowDeleteAll deleteAll = new PartySmallWindowDeleteAll();
				
				for (int x = 1; party.size() > x; x++)
				{//clears all the members partywindows and clears their party lists
					
					temp = (L2PcInstance)party.get(x);
					temp.setPartyMembers(null);
					temp.sendPacket(deleteAll);
					temp.sendPacket(msg);
				}

				player.sendPacket(deleteAll);	
				player.sendPacket(msg);
				player.setPartyMembers(null);
				party.clear();
			}
			else//Member is leaving
			{
				//member that is leaving is handled
				msg = new SystemMessage(SystemMessage.YOU_LEFT_PARTY);
				player.sendPacket(new PartySmallWindowDeleteAll());
				player.sendPacket(msg);
				player.setPartyMembers(null);
				//other members are told
				
				msg = new SystemMessage(SystemMessage.S1_LEFT_PARTY);
				msg.addString(player.getName());
				
				party.remove(player);//removes client from party list
				PartySmallWindowDelete deletePlayer = new PartySmallWindowDelete(player);
				for (int x = 0; party.size() > x; x++)
				{
					temp = (L2PcInstance)party.get(x);
					temp.sendPacket(deletePlayer);
					temp.sendPacket(msg);
					temp.removeStatusListener(player);
				}
				
				if (party.size() == 1)
				{
					temp = (L2PcInstance)party.get(0);
					temp.setPartyMembers(null);
				}
			}
		}
	}
	
	public String getType()
	{
		return _C__2B_REQUESTWITHDRAWALPARTY;
	}
}
