/*
 * $Header: /var/lib/gforge/chroot/cvsroot/nextg/CVSROOT/L2_Gameserver/java/net/sf/l2j/gameserver/clientpackets/UseItem.java,v 1.3 2004/08/05 00:53:40 nextg Exp $
 *
 * $Author: nextg $
 * $Date: 2004/08/05 00:53:40 $
 * $Revision: 1.3 $
 * $Log: UseItem.java,v $
 * Revision 1.3  2004/08/05 00:53:40  nextg
 * RuSh
 *
 * Revision 1.12  2004/08/04 21:13:52  l2chef
 * closest town calculation moved (NuocNam)
 *
 * Revision 1.11  2004/07/29 20:07:38  l2chef
 * patk/matk/pdef/mdef gets updates  (NuocNam/Nightmarez)
 *
 * Revision 1.10  2004/07/25 22:57:48  l2chef
 * pet system started (whatev)
 *
 * Revision 1.9  2004/07/23 01:45:56  l2chef
 * fixed inventoy update bug
 *
 * Revision 1.8  2004/07/19 02:03:40  l2chef
 * soulshot code added (MetalRabbit)
 *
 * Revision 1.7  2004/07/17 00:06:48  l2chef
 * equip and unequip of items it broadcasted to other players
 *
 * Revision 1.6  2004/07/13 23:05:40  l2chef
 * empty blocks commented
 *
 * Revision 1.5  2004/07/11 23:38:32  l2chef
 * handling for scroll of escape  (MetalRabbit)
 *
 * Revision 1.4  2004/07/07 23:51:55  l2chef
 * pAtk update contributed by MetalRabit
 *
 * Revision 1.3  2004/07/04 11:12:33  l2chef
 * logging is used instead of system.out
 *
 * Revision 1.2  2004/06/27 08:51:42  jeichhorn
 * Added copyright notice
 *
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 *
 * http://www.gnu.org/copyleft/gpl.html
 */
package net.sf.l2j.gameserver.clientpackets;

import java.io.IOException;
import java.util.ArrayList;
import java.util.logging.Logger;
import net.sf.l2j.gameserver.ClientThread;
import net.sf.l2j.gameserver.IdFactory;
import net.sf.l2j.gameserver.NpcDataTable;
import net.sf.l2j.gameserver.NpcTable;
import net.sf.l2j.gameserver.SkillTable;
import net.sf.l2j.gameserver.model.L2ItemInstance;
import net.sf.l2j.gameserver.model.L2NpcData;
import net.sf.l2j.gameserver.model.L2Object;
import net.sf.l2j.gameserver.model.L2PcInstance;
import net.sf.l2j.gameserver.model.L2Skill;
import net.sf.l2j.gameserver.model.L2World;
import net.sf.l2j.gameserver.serverpackets.CharInfo;
import net.sf.l2j.gameserver.serverpackets.EquipUpdate;
import net.sf.l2j.gameserver.serverpackets.InventoryUpdate;
import net.sf.l2j.gameserver.serverpackets.MagicSkillUser;
import net.sf.l2j.gameserver.serverpackets.NpcInfo;
import net.sf.l2j.gameserver.serverpackets.PetItemList;
import net.sf.l2j.gameserver.serverpackets.SetupGauge;
import net.sf.l2j.gameserver.serverpackets.SystemMessage;
import net.sf.l2j.gameserver.serverpackets.UserInfo;
import net.sf.l2j.gameserver.templates.L2Item;
import net.sf.l2j.gameserver.templates.L2Npc;
import net.sf.l2j.gameserver.templates.L2Weapon;
import net.sf.l2j.gameserver.serverpackets.ActionFailed;
import net.sf.l2j.gameserver.serverpackets.StopMove;
import net.sf.l2j.gameserver.serverpackets.TeleportToLocation;
import net.sf.l2j.gameserver.serverpackets.PetInfo;
import net.sf.l2j.gameserver.serverpackets.MagicSkillLaunched;
import net.sf.l2j.gameserver.model.L2PetInstance;
import net.sf.l2j.gameserver.MapRegionTable;

/**
 * This class ...
 * 
 * @version $Revision: 1.3 $ $Date: 2004/08/05 00:53:40 $
 */
public class UseItem extends ClientBasePacket
{
	private static Logger _log = Logger.getLogger(UseItem.class.getName());
	private static final String _C__14_USEITEM = "[C] 14 UseItem";
	/**
	 * packet type id 0x14
	 * format:		cd
	 * @param decrypt
	 */
	public UseItem(byte[] decrypt, ClientThread client) throws IOException
	{
		super(decrypt);
		int objectId = readD();
		
		_log.fine("use item:" + objectId);
		L2PcInstance activeChar = client.getActiveChar();
		
		L2ItemInstance item = activeChar.getInventory().getItem(objectId);
		if (item != null && item.isEquipable())
		{
			ArrayList items = activeChar.getInventory().equipItem(item);
			
			if (item.getItem().getType2() == L2Item.TYPE2_WEAPON)
			{
				activeChar.updatePAtk();
				activeChar.updateMAtk();
			}
			else if (item.getItem().getType2() == L2Item.TYPE2_SHIELD_ARMOR)
			{
				activeChar.updatePDef();
			} 
			else 	if (item.getItem().getType2() == L2Item.TYPE2_ACCESSORY)
			{
				activeChar.updateMDef();
			}
			
			SystemMessage sm = new SystemMessage(49);
			sm.addItemName(item.getItemId());
			activeChar.sendPacket(sm);
			
			InventoryUpdate iu = new InventoryUpdate(items);
			activeChar.sendPacket(iu);
			
			
			UserInfo ui = new UserInfo(activeChar);
			activeChar.sendPacket(ui);
			
			for (int i = 0; i < items.size(); i++)
			{
				L2ItemInstance tempItem = (L2ItemInstance) items.get(i);
				if (tempItem.isEquipped())
				{
					EquipUpdate eu = new EquipUpdate(tempItem, 1);
					activeChar.sendPacket(eu);
				}
			}
			
			CharInfo info = new CharInfo(activeChar);
			activeChar.broadcastPacket(info);
		}
		else
		{
			_log.fine("item not equipable id:"+ item.getItemId());
			switch (item.getItemId())
			{
				case (1665):
					// world map
					break;
				case (2375):summonwolf(activeChar);
					break;
				case (3500):summon_hatchling_of_wind(activeChar);
					break;
				case (3501):summon_hatchling_of_star(activeChar);
					break;
				case (3502):summon_hatchling_of_twilight(activeChar);
					break;
				case (736):
					useScrollOfEscape(activeChar, item);
					break;

//			SoulShots
				case (1835): 
//				NGrade
				case (1463):
//				DGrade
				case (1464):
//				CGrade
				case (1465):
//				BGrade
				case (1466):
//				AGrade
				case (1467):
//				SGrade
					useSoulShot(activeChar, item);
					break;
					
			}
		}
	}
	
	
	/**
	 * @param client
	 * @param objectId
	 * @param activeChar
	 * @param con
	 * @param item
	 * @throws IOException
	 */
	private void summonwolf(L2PcInstance activeChar) throws IOException
	{
		
			if (activeChar.getPet()==null)
			{
				
				L2Npc petTemplate = NpcTable.getInstance().getTemplate(12077);
				

				L2PetInstance newpet = new L2PetInstance(petTemplate);
				
				L2NpcData mobData = NpcDataTable.getInstance().getTemplate(12077);
				newpet.setNpcId(12077);
				newpet.setTitle(activeChar.getName());
				
				newpet.setObjectId(IdFactory.getInstance().getNextId());
				newpet.setX(activeChar.getX()+50);
				newpet.setY(activeChar.getY()+100);
				newpet.setZ(activeChar.getZ());
				newpet.setLevel(mobData.getLevel());
				newpet.setMaxHp(mobData.getHp());
				newpet.setCurrentHp(mobData.getHp());
				newpet.setWalkSpeed(40);// these values are not correct and will cause miscalulation
				newpet.setRunSpeed(80);
				newpet.setPhysicalAttack(mobData.getPatk());
				newpet.setPhysicalDefense(mobData.getPdef());
				newpet.setHeading(activeChar.getHeading());
				newpet.setUnknown1(1.08);
				newpet.setUnknown2(0.9983664);
				newpet.setAttackRange(mobData.getAttackrange());
				
				
				L2World.getInstance().storeObject(newpet); // this is just a hack to make the id globally known
				L2World.getInstance().addVisibleObject(newpet);	
				
				newpet.setRunning(true);
				
				
				MagicSkillUser msk = new MagicSkillUser(activeChar, 2046, 1, 1000, 600000);
				activeChar.sendPacket(msk);
				
				PetInfo ownerni = new PetInfo(newpet);
				NpcInfo ni = new NpcInfo(newpet);
				
				activeChar.broadcastPacket(ni);
				activeChar.sendPacket(ownerni);
				activeChar.sendPacket(new PetItemList(newpet));
			try
			{
				Thread.sleep(900);
			}
			catch (InterruptedException e)
			{
				// ignore interruptions
			}

			
			activeChar.sendPacket(new MagicSkillLaunched(activeChar,2046,1));
			
			activeChar.setPet(newpet);
			newpet.setOwner(activeChar.getObjectId());
			
			}
	}
	private void summon_hatchling_of_wind(L2PcInstance activeChar) throws IOException
	{
		
			if (activeChar.getPet()==null)
			{
				
				L2Npc petTemplate = NpcTable.getInstance().getTemplate(12311);
				

				L2PetInstance newpet = new L2PetInstance(petTemplate);
				
				L2NpcData mobData = NpcDataTable.getInstance().getTemplate(12311);
				
				newpet.setNpcId(12311);
				newpet.setTitle(activeChar.getName());
				newpet.setObjectId(IdFactory.getInstance().getNextId());
				newpet.setX(activeChar.getX()+50);
				newpet.setY(activeChar.getY()+100);
				newpet.setZ(activeChar.getZ());
				newpet.setLevel(mobData.getLevel());
				newpet.setMaxHp(mobData.getHp());
				newpet.setCurrentHp(mobData.getHp());
				newpet.setWalkSpeed(40);// these values are not correct and will cause miscalulation
				newpet.setRunSpeed(80);
				newpet.setPhysicalAttack(mobData.getPatk());
				newpet.setPhysicalDefense(mobData.getPdef());
				newpet.setHeading(activeChar.getHeading());
				newpet.setUnknown1(1.08);
				newpet.setUnknown2(0.9983664);
				L2World.getInstance().storeObject(newpet); // this is just a hack to make the id globally known
				L2World.getInstance().addVisibleObject(newpet);	
				newpet.setRunning(true);
				
				MagicSkillUser msk = new MagicSkillUser(activeChar, 2046, 1, 1000, 600000);
				activeChar.sendPacket(msk);
				
				PetInfo ownerni = new PetInfo(newpet);
				NpcInfo ni = new NpcInfo(newpet);
				
				activeChar.broadcastPacket(ni);
				activeChar.sendPacket(ownerni);
				activeChar.sendPacket(new PetItemList(newpet));
			try
			{
				Thread.sleep(900);
			}
			catch (InterruptedException e)
			{
				// ignore interruptions
			}

			
			activeChar.sendPacket(new MagicSkillLaunched(activeChar,2046,1));
			
			activeChar.setPet(newpet);
			newpet.setOwner(activeChar.getObjectId());
			
			}
	}
	private void summon_hatchling_of_star(L2PcInstance activeChar) throws IOException
	{
		
			if (activeChar.getPet()==null)
			{
				
				L2Npc petTemplate = NpcTable.getInstance().getTemplate(12312);
				

				L2PetInstance newpet = new L2PetInstance(petTemplate);
				
				L2NpcData mobData = NpcDataTable.getInstance().getTemplate(12312);
				newpet.setNpcId(12312);
				newpet.setTitle(activeChar.getName());
				newpet.setObjectId(IdFactory.getInstance().getNextId());
				newpet.setX(activeChar.getX()+50);
				newpet.setY(activeChar.getY()+100);
				newpet.setZ(activeChar.getZ());
				newpet.setLevel(mobData.getLevel());
				newpet.setMaxHp(mobData.getHp());
				newpet.setCurrentHp(mobData.getHp());
				newpet.setWalkSpeed(40);// these values are not correct and will cause miscalulation
				newpet.setRunSpeed(80);
				newpet.setPhysicalAttack(mobData.getPatk());
				newpet.setPhysicalDefense(mobData.getPdef());
				newpet.setHeading(activeChar.getHeading());
				newpet.setUnknown1(1.08);
				newpet.setUnknown2(0.9983664);
				L2World.getInstance().storeObject(newpet); // this is just a hack to make the id globally known
				L2World.getInstance().addVisibleObject(newpet);	
				newpet.setRunning(true);
				
				MagicSkillUser msk = new MagicSkillUser(activeChar, 2046, 1, 1000, 600000);
				activeChar.sendPacket(msk);
				
				PetInfo ownerni = new PetInfo(newpet);
				NpcInfo ni = new NpcInfo(newpet);
				
				activeChar.broadcastPacket(ni);
				activeChar.sendPacket(ownerni);	
				activeChar.sendPacket(new PetItemList(newpet));
			try
			{
				Thread.sleep(900);
			}
			catch (InterruptedException e)
			{
				// ignore interruptions
			}

			
			activeChar.sendPacket(new MagicSkillLaunched(activeChar,2046,1));
			
			activeChar.setPet(newpet);
			newpet.setOwner(activeChar.getObjectId());
			
			}
	}
	private void summon_hatchling_of_twilight(L2PcInstance activeChar) throws IOException
	{
		
			if (activeChar.getPet()==null)
			{
				
				L2Npc petTemplate = NpcTable.getInstance().getTemplate(12313);
				

				L2PetInstance newpet = new L2PetInstance(petTemplate);
				
				L2NpcData mobData = NpcDataTable.getInstance().getTemplate(12313);
				
				newpet.setNpcId(12313);
				newpet.setTitle(activeChar.getName());
				newpet.setObjectId(IdFactory.getInstance().getNextId());
				newpet.setX(activeChar.getX()+50);
				newpet.setY(activeChar.getY()+100);
				newpet.setZ(activeChar.getZ());
				newpet.setLevel(mobData.getLevel());
				newpet.setMaxHp(mobData.getHp());
				newpet.setCurrentHp(mobData.getHp());
				newpet.setWalkSpeed(40);// these values are not correct and will cause miscalulation
				newpet.setRunSpeed(80);
				newpet.setPhysicalAttack(mobData.getPatk());
				newpet.setPhysicalDefense(mobData.getPdef());
				newpet.setHeading(activeChar.getHeading());
				newpet.setUnknown1(1.08);
				newpet.setUnknown2(0.9983664);
				L2World.getInstance().storeObject(newpet); // this is just a hack to make the id globally known
				L2World.getInstance().addVisibleObject(newpet);	
				newpet.setRunning(true);
				
				MagicSkillUser msk = new MagicSkillUser(activeChar, 2046, 1, 1000, 600000);
				activeChar.sendPacket(msk);
				
				PetInfo ownerni = new PetInfo(newpet);
				NpcInfo ni = new NpcInfo(newpet);
				
				activeChar.broadcastPacket(ni);
				activeChar.sendPacket(ownerni);
				activeChar.sendPacket(new PetItemList(newpet));
			try
			{
				Thread.sleep(900);
			}
			catch (InterruptedException e)
			{
				// ignore interruptions
			}

			
			activeChar.sendPacket(new MagicSkillLaunched(activeChar,2046,1));
			
			activeChar.setPet(newpet);
			newpet.setOwner(activeChar.getObjectId());
			
			}
	}
	private void useScrollOfEscape(L2PcInstance activeChar, L2ItemInstance item) throws IOException
	{
		String townCordsString = MapRegionTable.getInstance().getClosestTownCords(activeChar);
		String[] temp = null;
		temp = townCordsString.split("!");
		
		int townX = Integer.parseInt(temp[0]);
		int townY = Integer.parseInt(temp[1]);
		int townZ = Integer.parseInt(temp[2]);
		
		//SoE Animation section
		activeChar.setTarget(activeChar);
		L2Skill skill = SkillTable.getInstance().getInfo(1050, 1);
		MagicSkillUser msk = new MagicSkillUser(activeChar, 1050, 1,20000,0);
		activeChar.sendPacket(msk);
		activeChar.broadcastPacket(msk);
		SetupGauge sg = new SetupGauge(0, skill.getSkillTime());
		activeChar.sendPacket(sg);
		
		if (skill.getSkillTime() > 200)
		{
			try
			{
				Thread.sleep(skill.getSkillTime()-200);
			}
			catch (InterruptedException e)
			{
				// ignore interrupts
			}
			
		}
		
		//End SoE Animation section
		
		
		//Packets and other updates, teleport also
		StopMove sm = new StopMove(activeChar);
		activeChar.sendPacket(sm);
		activeChar.broadcastPacket(sm);

		ActionFailed af = new ActionFailed();
		activeChar.sendPacket(af);
		
		removeItemFromInventory(activeChar, item, 1);

		L2World.getInstance().removeVisibleObject(activeChar);
		activeChar.removeAllKnownObjects();
		
		
		TeleportToLocation teleport = new TeleportToLocation(activeChar, townX, townY, townZ);
		activeChar.sendPacket(teleport);
		activeChar.broadcastPacket(teleport);
		activeChar.setX(townX);
		activeChar.setY(townY);
		activeChar.setZ(townZ);

		//Disable movement right after the animation is done to prevent the exploit that lets you pick up the items you dropped on death
		try
		{
			Thread.sleep(2000);
		}
		catch (InterruptedException e)
		{
			// ignore interrupts
		}
	}
	
	
	/**
	 * @param activeChar
	 * @param item
	 */
	private void removeItemFromInventory(L2PcInstance activeChar, L2ItemInstance item, int count)
	{
		L2ItemInstance item2 = activeChar.getInventory().destroyItem(item.getObjectId(), count);
		
		InventoryUpdate iu = new InventoryUpdate();
		if (item2.getCount() == 0)
		{
			iu.addRemovedItem(item2);
		}
		else
		{
			iu.addModifiedItem(item2);
		}
		
		activeChar.sendPacket(iu);
	}


	private void useSoulShot(L2PcInstance activeChar, L2ItemInstance soulShotItem)
	{
		if (activeChar.getActiveSoulshotGrade() == 0)
		{
			int SoulshotId = soulShotItem.getItemId();
			L2Weapon weapon = activeChar.getActiveWeapon();
			if (weapon == null)
			{
				activeChar.sendPacket(new SystemMessage(SystemMessage.CANNOT_USE_SOULSHOTS));
				return;
			}
			int grade = weapon.getCrystalType();
			int soulShotConsumption = weapon.getSoulShotCount();
			int count = soulShotItem.getCount();
			
			
			if (soulShotConsumption == 0)
			{
				//	 Can't use soulshots
				activeChar.sendPacket(new SystemMessage(SystemMessage.CANNOT_USE_SOULSHOTS));
				return;
			}
			
			
			if ((grade == L2Item.CRYSTAL_NONE && SoulshotId == 1835) || 
				(grade == L2Item.CRYSTAL_D && SoulshotId == 1463) || 
				(grade == L2Item.CRYSTAL_C && SoulshotId == 1464) || 
				(grade == L2Item.CRYSTAL_B && SoulshotId == 1465) || 
				(grade == L2Item.CRYSTAL_A && SoulshotId == 1466) || 
				(grade == L2Item.CRYSTAL_S && SoulshotId == 1467))
			{
				// correct grade for weapon
			}
			else
			{
				//	 Type Mismatch
				activeChar.sendPacket(new SystemMessage(SystemMessage.SOULSHOTS_GRADE_MISMATCH));
				return;
			}
			
			
			if (!(count >= soulShotConsumption))
			{
				//	 Not Enough Soulshots
				activeChar.sendPacket(new SystemMessage(SystemMessage.NOT_ENOUGH_SOULSHOTS));
				return;
			}
			
			removeItemFromInventory(activeChar, soulShotItem, soulShotConsumption);

			activeChar.setActiveSoulshotGrade(grade);
			activeChar.sendPacket(new SystemMessage(342));
			L2Object OldTarget = activeChar.getTarget();
			activeChar.setTarget(activeChar);
			MagicSkillUser MSU = new MagicSkillUser(activeChar,2039,1,0,0);
			activeChar.sendPacket(MSU);
			activeChar.broadcastPacket(MSU);
			activeChar.setTarget(OldTarget);
		}
	}

	
	
	/* (non-Javadoc)
	 * @see net.sf.l2j.gameserver.clientpackets.ClientBasePacket#getType()
	 */
	public String getType()
	{
		return _C__14_USEITEM;
	}
}
