/*
 * $Header: /var/lib/gforge/chroot/cvsroot/nextg/CVSROOT/L2_Gameserver/java/net/sf/l2j/gameserver/model/L2Character.java,v 1.3 2004/08/05 00:53:40 nextg Exp $
 *
 * $Author: nextg $
 * $Date: 2004/08/05 00:53:40 $
 * $Revision: 1.3 $
 * $Log: L2Character.java,v $
 * Revision 1.3  2004/08/05 00:53:40  nextg
 * RuSh
 *
 * Revision 1.27  2004/08/04 20:43:46  l2chef
 * closest town calculation moved (NuocNam)
 *
 * Revision 1.26  2004/08/02 22:34:26  l2chef
 * divide by zero prevented when pdef of npc2.csv is zero
 *
 * Revision 1.25  2004/08/02 00:07:35  l2chef
 * better solution to drop item problem
 * moveto uses the original z coord
 *
 * Revision 1.24  2004/08/01 12:17:18  l2chef
 * teleport array fixed (NuocNam)
 *
 * Revision 1.23  2004/07/30 22:28:29  l2chef
 * teleport destinations bases on maptile (NuocNam)
 *
 * Revision 1.22  2004/07/30 10:24:30  l2chef
 * no regeneration when dead, z coordinate is updated to requested z when target is reached.
 *
 * Revision 1.21  2004/07/29 23:36:58  l2chef
 * invalid speed fix (whatev)
 *
 * Revision 1.20  2004/07/29 20:08:20  l2chef
 * damage calculation considers Pdef (NuocNam)
 *
 * Revision 1.19  2004/07/29 00:00:04  l2chef
 * knowPlayers is now a Set to prevent duplicates
 *
 * Revision 1.18  2004/07/25 22:59:09  l2chef
 * pet system started (whatev)
 *
 * Revision 1.17  2004/07/25 00:38:09  l2chef
 * moving objects appear now as moving when they get into viewrange (NuocNam)
 *
 * Revision 1.16  2004/07/23 22:51:33  l2chef
 * multiple attacks at the same time are now prevented
 *
 * Revision 1.15  2004/07/23 01:46:55  l2chef
 * all object spawn and delete is now handeld in L2PcInstance
 * knownobject handling is moved to L2Object
 *
 * Revision 1.14  2004/07/19 23:15:37  l2chef
 * removed comment
 *
 * Revision 1.13  2004/07/19 02:05:57  l2chef
 * decay timer moved to npcinstance
 * soulshot code added
 * movement calculation enhanced
 *
 * Revision 1.12  2004/07/18 17:37:38  l2chef
 * removeAllKnownObjects will cause a notify to all object to remove this instance
 * hp/mp regeneration is now triggered differently.
 *
 * Revision 1.11  2004/07/17 23:22:44  l2chef
 * moveTo with offset is working correct now.
 * all timer tasks should be crash safe.
 * attacker is not warped to target on ranged attacks any more.
 *
 * Revision 1.10  2004/07/14 22:09:57  l2chef
 * enabled move state again
 *
 * Revision 1.9  2004/07/12 20:56:00  l2chef
 * fixed a int overflow problem
 * fixed disapprear bug. destination was not set when too close. so the mob ended up at 0,0,0
 *
 * Revision 1.8  2004/07/11 23:02:21  l2chef
 * temporary nearest town calucation added  (MetalRabbit)
 * damage calculation returned to old one
 *
 * Revision 1.7  2004/07/11 11:46:48  l2chef
 * damage calculation by MetalRabbit. not final
 *
 * Revision 1.6  2004/07/04 17:43:35  l2chef
 * level up animation is shown
 *
 * Revision 1.5  2004/07/04 14:35:07  jeichhorn
 * added methods to increase and decrease the level
 *
 * Revision 1.4  2004/07/04 11:13:27  l2chef
 * logging is used instead of system.out
 *
 * Revision 1.3  2004/06/30 21:51:32  l2chef
 * using jdk logger instead of println
 *
 * Revision 1.2  2004/06/27 08:51:42  jeichhorn
 * Added copyright notice
 *
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 *
 * http://www.gnu.org/copyleft/gpl.html
 */
package net.sf.l2j.gameserver.model;

import java.util.ArrayList;
import java.util.Random;
import java.util.Set;
import java.util.Timer;
import java.util.TimerTask;
import java.util.logging.Logger;

import net.sf.l2j.gameserver.serverpackets.ActionFailed;
import net.sf.l2j.gameserver.serverpackets.Attack;
import net.sf.l2j.gameserver.serverpackets.AutoAttackStart;
import net.sf.l2j.gameserver.serverpackets.AutoAttackStop;
import net.sf.l2j.gameserver.serverpackets.CharMoveToLocation;
import net.sf.l2j.gameserver.serverpackets.Die;
import net.sf.l2j.gameserver.serverpackets.FinishRotation;
import net.sf.l2j.gameserver.serverpackets.MoveToPawn;
import net.sf.l2j.gameserver.serverpackets.ServerBasePacket;
import net.sf.l2j.gameserver.serverpackets.SetToLocation;
import net.sf.l2j.gameserver.serverpackets.SocialAction;
import net.sf.l2j.gameserver.serverpackets.StatusUpdate;
import net.sf.l2j.gameserver.serverpackets.StopMove;
import net.sf.l2j.gameserver.serverpackets.SystemMessage;
import net.sf.l2j.gameserver.templates.L2Weapon;

/**
 * This class ...
 * 
 * @version $Revision: 1.3 $ $Date: 2004/08/05 00:53:40 $
 */
public abstract class L2Character extends L2Object
{	
	private static final Logger _log = Logger.getLogger(L2Character.class.getName());
			
	class ArriveTask extends TimerTask
	{
		L2Character _instance;
		
		public ArriveTask(L2Character instance)
		{
			_instance = instance;
		}
		
		public void run()
		{
			try
			{
				_instance.onTargetReached();
			}
			catch (Exception e)
			{
				e.printStackTrace();
			}
		}
	}

	class AttackTask extends TimerTask
	{
		L2Character _instance;
		
		public AttackTask(L2Character instance)
		{
			_instance = instance;
		}
		
		public void run()
		{
			try
			{
				_instance.onAttackTimer();
			}
			catch (Exception e)
			{
				e.printStackTrace();
			}
		}
	}

	class HitTask extends TimerTask
	{
		L2Character _instance;
		L2Character _target;
		int _damage;
		boolean _crit;
		boolean _miss;
		boolean _soulshot;
		
		public HitTask(L2Character instance, L2Character target, int damage, boolean crit, boolean miss, boolean soulshot)
		{
			_instance = instance;
			_target = target;
			_damage = damage;
			_crit = crit;
			_miss = miss;
			_soulshot = soulshot;
		}
		
		public void run()
		{
			try
			{
				_instance.onHitTimer(_target, _damage, _crit, _miss, _soulshot);
			}
			catch (Exception e)
			{
				e.printStackTrace();
			}
		}
	}

	class HpRegenTask extends TimerTask
	{
		L2Character _instance;
		
		
		public HpRegenTask(L2Character instance)
		{
			_instance = instance;
		}
		
		public void run()
		{
			synchronized(_hpLock)
			{
				double nowHp = _instance.getCurrentHp();
				if (_instance.getCurrentHp() < _instance.getMaxHp())
				{
					nowHp += 1.6;
					if (nowHp > _instance.getMaxHp())
					{
						nowHp = _instance.getMaxHp();
					}
					
					_instance.setCurrentHp(nowHp);
				}
			}
		}
	}
	
	class MpRegenTask extends TimerTask
	{
		L2Character _instance;
		
		
		public MpRegenTask(L2Character instance)
		{
			_instance = instance;
		}
		
		public void run()
		{
			synchronized(_mpLock)
			{
				double nowMp = _instance.getCurrentMp();
	
				if (_instance.getCurrentMp() < _instance.getMaxMp())
				{
					nowMp += 0.6;
					_instance.setCurrentMp(nowMp);
				}
			}
		}
	}

	
	public long serialVersionUID = 0x12341234; 
	// this array contains all clients that need to be notified about hp/mp updates
	private ArrayList _statusListener = new ArrayList();

	private static Timer _attackTimer = new Timer(true);
	private AttackTask _currentAttackTask;

	private static Timer _hitTimer = new Timer(true);
	private HitTask _currentHitTask;

	private static Timer _regenTimer = new Timer(true);
	private MpRegenTask _mpRegTask;
	private Object _mpLock = new Object();
	private boolean _mpRegenActive;
	private HpRegenTask _hpRegTask = new HpRegenTask(this);
	private Object _hpLock = new Object();
	private boolean _hpRegenActive;

	// this is needed for movement target updates
	private int _moveOffset;
	private L2PcInstance _moveToPawn;
	
	private float _dx;
	private float _dy;
	private float _dz;
	private long _moveStartTime;
	private double _xAddition;
	private double _yAddition;
	private long _timeToTarget;
	private static Timer _moveTimer = new Timer(true);
	private ArriveTask _currentMoveTask;
	

	
	private static Random _rnd = new Random();

	private String _name;
	private int _level = 1;
	private int _maxHp;
	private double _currentHp;
	private int _maxMp;
	private double _currentMp;
	private int _accuracy;
	private int _criticalHit;
	private int _evasionRate;
	private int _magicalAttack;
	private int _magicalDefense;
	private int _magicalSpeed;
	private int _physicalAttack;
	private int _physicalDefense;
	private int _physicalSpeed;
	private int _runSpeed;
	private int _walkSpeed;
	
	private int _int;
	private int _str;
	private int _con;
	private int _dex;
	private int _men;
	private int _wit;
	
	
	private int _face;
	private int _hairStyle;
	private int _hairColor;
	
	private int _sex;
	private int _heading;

	private int _xDestination;
	private int _yDestination;
	private int _zDestination;
	
	private double _unknown1;  
	private double _unknown2;  
	private double _collisionRadius;   
	private double _collisionHeight; // this is  positioning the model relative to the ground 
	
	private L2Object _target;
	
	
	private int _currentState = STATE_IDLE;
	
	public static final int STATE_IDLE = 0;
	public static final int STATE_PICKUP_ITEM = 1;
	public static final int STATE_CASTING = 2;
	public static final int STATE_RESTING = 3;
//	public static final int STATE_MOVING = 4;
	public static final int STATE_ATTACKING = 5;
	public static final int STATE_RANDOM_WALK = 6;
	public static final int STATE_INTERACT = 7;
	public static final int STATE_FOLLOW = 8;
	

	private boolean _inCombat;
	private boolean _moving;
	private boolean _movingToPawn;
	
	private int _pawnOffset;
	private L2Object _pawnTarget;
	
	
	public boolean knownsObject(L2Object object)
	{
		return _knownObjects.contains(object);
	}
	
	/**
	 * 
	 */
	public void onDecay()
	{
		L2World.getInstance().removeVisibleObject(this);
	}

	public void addStatusListener(L2Character object)
	{
		_statusListener.add(object);
	}
	
	private ArrayList getStatusListener()
	{
		return _statusListener;
	}

	public void removeStatusListener(L2Character object)
	{
		_statusListener.remove(object);
	}

	/**
	 * @return
	 */
	public int getHeading()
	{
		return _heading;
	}

	/**
	 * @param heading
	 */
	public void setHeading(int heading)
	{
		_heading = heading;
	}

	/**
	 * @return
	 */
	public int getXdestination()
	{
		return _xDestination;
	}

	/**
	 * @param x1
	 */
	public void setXdestination(int x1)
	{
		_xDestination = x1;
	}

	/**
	 * @return
	 */
	public int getYdestination()
	{
		return _yDestination;
	}

	/**
	 * @param y1
	 */
	public void setYdestination(int y1)
	{
		_yDestination = y1;
	}

	/**
	 * @return
	 */
	public int getZdestination()
	{
		return _zDestination;
	}

	/**
	 * @param z1
	 */
	public void setZdestination(int z1)
	{
		_zDestination = z1;
	}

	
	
	/* (non-Javadoc)
	 * @see net.sf.l2j.gameserver.model.L2Object#getX()
	 */
	public int getX()
	{
		if (!isMoving())
		{	
			return super.getX();
		}
		else
		{
			long elapsed = System.currentTimeMillis() - _moveStartTime;
			int diff = (int) (elapsed * _xAddition);
			int remain = Math.abs(getXdestination()-super.getX()) - Math.abs(diff);
			if ( remain > 0)
			{	
				return super.getX() + diff;
			}
			else
			{
				return getXdestination();
			}
		}
	}

	/* (non-Javadoc)
	 * @see net.sf.l2j.gameserver.model.L2Object#getY()
	 */
	public int getY()
	{
		if (!isMoving())
		{	
			return super.getY();
		}
		else
		{
			long elapsed = System.currentTimeMillis() - _moveStartTime;
			int diff = (int) (elapsed * _yAddition);
			int remain = Math.abs(getYdestination()-super.getY()) - Math.abs(diff);
			if ( remain > 0)
			{	
				return super.getY() + diff;
			}
			else
			{
				return getYdestination();
			}
		}
	}
	/* (non-Javadoc)
	 * @see net.sf.l2j.gameserver.model.L2Object#getZ()
	 */
	public int getZ()
	{
		if (!isMoving())
		{	
			return super.getZ();
		}
		else
		{
			return super.getZ();
		}
	}

	/**
	 * @return
	 */
	public boolean isMoving()
	{
		return _moving; 
	}

	public void stopMove()
	{
		if (_currentMoveTask != null)
		{
			_currentMoveTask.cancel();
			_currentMoveTask = null;
		}
		
		// copy calculated position to current position
		setX(getX());
		setY(getY());
		setZ(getZ()); // TODO this the initially requested z coord, it has to be replaced with the real Z 
		setIsMoving(false);
	}
	
	/**
	 * @return
	 */
	public int getCon()
	{
		return _con;
	}

	/**
	 * @param con
	 */
	public void setCon(int con)
	{
		_con = con;
	}

	/**
	 * @return
	 */
	public int getDex()
	{
		return _dex;
	}

	/**
	 * @param dex
	 */
	public void setDex(int dex)
	{
		_dex = dex;
	}

	/**
	 * @return
	 */
	public int getInt()
	{
		return _int;
	}

	/**
	 * @param int1
	 */
	public void setInt(int int1)
	{
		_int = int1;
	}

	/**
	 * @return
	 */
	public int getMen()
	{
		return _men;
	}

	/**
	 * @param men
	 */
	public void setMen(int men)
	{
		_men = men;
	}

	/**
	 * @return
	 */
	public int getStr()
	{
		return _str;
	}

	/**
	 * @param str
	 */
	public void setStr(int str)
	{
		_str = str;
	}

	/**
	 * @return
	 */
	public int getWit()
	{
		return _wit;
	}

	/**
	 * @param wit
	 */
	public void setWit(int wit)
	{
		_wit = wit;
	}

	/**
	 * @return
	 */
	public double getCurrentHp()
	{
		return _currentHp;
	}

	/**
	 * @param currentHp
	 */
	public void setCurrentHp(double currentHp)
	{
		_currentHp = currentHp;
		if (_currentHp >= getMaxHp())
		{
			stopHpRegeneration();
			
			_currentHp = getMaxHp();
		}
		else if (!_hpRegenActive && !isDead())
		{
			startHpRegeneration();
		}
		
		broadcastStatusUpdate();
	}

	/**
	 * 
	 */
	public void stopHpRegeneration()
	{
		if (_hpRegenActive)
		{
			_hpRegTask.cancel();
			_hpRegTask = null;
			_hpRegenActive = false;
			_log.fine("HP regen stop");
		}
	}

	/**
	 * 
	 */
	private void startHpRegeneration()
	{
		_log.fine("HP regen started");
		_hpRegTask = new HpRegenTask(this);
		_regenTimer.scheduleAtFixedRate(_hpRegTask, 1000, 1000);
		_hpRegenActive = true;
	}

	/**
	 * @return
	 */
	public double getCurrentMp()
	{
		return _currentMp;
	}

	/**
	 * @param currentMp
	 */
	public void setCurrentMp(double currentMp)
	{
		_currentMp = currentMp;

		if (_currentMp >= getMaxMp())
		{
			stopMpRegeneration();

			_currentMp = getMaxMp();
		}
		else if (!_mpRegenActive && !isDead())
		{
			startMpRegeneration();
		}
		
		broadcastStatusUpdate();
	}

	/**
	 * 
	 */
	private void startMpRegeneration()
	{
		_mpRegTask = new MpRegenTask(this);
		_log.fine("MP regen started");
		
		_regenTimer.scheduleAtFixedRate(_mpRegTask, 1000, 1000);
		_mpRegenActive = true;
	}

	/**
	 * 
	 */
	public void stopMpRegeneration()
	{
		if (_mpRegenActive)
		{
			_mpRegTask.cancel();
			_mpRegTask = null;
			_log.fine("Mp regen stopped");
			_mpRegenActive = false;
		}
	}

	public void broadcastStatusUpdate()
	{
		ArrayList list = getStatusListener();
		if (list.isEmpty())
		{
			return;
		}

		StatusUpdate su = new StatusUpdate(getObjectId());
		su.addAttribute(StatusUpdate.CUR_HP,(int)getCurrentHp());
		su.addAttribute(StatusUpdate.CUR_MP,(int)getCurrentMp());

		for (int i=0; i<list.size(); i++)
		{
			L2Character temp = (L2Character) list.get(i);
			if (temp instanceof L2PcInstance)
			{
				L2PcInstance player = (L2PcInstance) temp;
				try
				{
					player.
					sendPacket(su);
				}
				catch (Exception e1)
				{
					e1.printStackTrace();
				}
			}
		}
	}
	 
	
	/**
	 * @return
	 */
	public int getMaxHp()
	{
		return _maxHp;
	}

	/**
	 * @param maxHp
	 */
	public void setMaxHp(int maxHp)
	{
		_maxHp = maxHp;
	}

	/**
	 * @return
	 */
	public int getMaxMp()
	{
		return _maxMp;
	}

	/**
	 * @param maxMp
	 */
	public void setMaxMp(int maxMp)
	{
		_maxMp = maxMp;
	}

	/**
	 * @return
	 */
	public int getAccuracy()
	{
		return _accuracy;
	}

	/**
	 * @param accuracy
	 */
	public void setAccuracy(int accuracy)
	{
		_accuracy = accuracy;
	}

	/**
	 * @return
	 */
	public int getCriticalHit()
	{
		return _criticalHit;
	}

	/**
	 * @param criticalHit
	 */
	public void setCriticalHit(int criticalHit)
	{
		_criticalHit = criticalHit;
	}

	/**
	 * @return
	 */
	public int getEvasionRate()
	{
		return _evasionRate;
	}

	/**
	 * @param evasionRate
	 */
	public void setEvasionRate(int evasionRate)
	{
		_evasionRate = evasionRate;
	}

	/**
	 * @return
	 */
	public int getFace()
	{
		return _face;
	}

	/**
	 * @param face
	 */
	public void setFace(int face)
	{
		_face = face;
	}

	/**
	 * @return
	 */
	public int getHairColor()
	{
		return _hairColor;
	}

	/**
	 * @param hairColor
	 */
	public void setHairColor(int hairColor)
	{
		_hairColor = hairColor;
	}

	/**
	 * @return
	 */
	public int getHairStyle()
	{
		return _hairStyle;
	}

	/**
	 * @param hairStyle
	 */
	public void setHairStyle(int hairStyle)
	{
		_hairStyle = hairStyle;
	}

	/**
	 * @return
	 */
	public int getLevel()
	{
		return _level;
	}
	
	public void increaseLevel()
	{
	    _log.finest("increasing level of " + getName());
	    _level++;
	    
		StatusUpdate su = new StatusUpdate(getObjectId());
		su.addAttribute(StatusUpdate.LEVEL, _level);
		sendPacket(su);
		
		sendPacket(new SystemMessage(SystemMessage.YOU_INCREASED_YOUR_LEVEL));
		
		SocialAction sa = new SocialAction(getObjectId(), 15);
		broadcastPacket(sa);
		sendPacket(sa);
	}
	
	public void decreaseLevel()
	{
	    _log.finest("increasing level of " + getName());
	    _level--;
	    
		StatusUpdate su = new StatusUpdate(getObjectId());
		su.addAttribute(StatusUpdate.LEVEL, _level);
		sendPacket(su);
	}

	/**
	 * @param level
	 */
	public void setLevel(int level)
	{
		_level = level;
	}

	/**
	 * @return
	 */
	public int getMagicalAttack()
	{
		return _magicalAttack;
	}

	/**
	 * @param magicalAttack
	 */
	public void setMagicalAttack(int magicalAttack)
	{
		_magicalAttack = magicalAttack;
	}

	/**
	 * @return
	 */
	public int getMagicalDefense()
	{
		return _magicalDefense;
	}

	/**
	 * @param magicalDefense
	 */
	public void setMagicalDefense(int magicalDefense)
	{
		_magicalDefense = magicalDefense;
	}

	/**
	 * @return
	 */
	public int getMagicalSpeed()
	{
		return _magicalSpeed;
	}

	/**
	 * @param magicalSpeed
	 */
	public void setMagicalSpeed(int magicalSpeed)
	{
		_magicalSpeed = magicalSpeed;
	}

	/**
	 * @return
	 */
	public String getName()
	{
		return _name;
	}

	/**
	 * @param name
	 */
	public void setName(String name)
	{
		_name = name;
	}

	/**
	 * @return
	 */
	public int getPhysicalAttack()
	{
		return _physicalAttack;
	}

	/**
	 * @param physicalAttack
	 */
	public void setPhysicalAttack(int physicalAttack)
	{
		_physicalAttack = physicalAttack;
	}

	/**
	 * @return
	 */
	public int getPhysicalDefense()
	{
		return _physicalDefense;
	}

	/**
	 * @param physicalDefense
	 */
	public void setPhysicalDefense(int physicalDefense)
	{
		_physicalDefense = physicalDefense;
	}

	/**
	 * @return
	 */
	public int getPhysicalSpeed()
	{
		return _physicalSpeed;
	}

	/**
	 * @param physicalSpeed
	 */
	public void setPhysicalSpeed(int physicalSpeed)
	{
		_physicalSpeed = physicalSpeed;
	}

	public boolean isMale()
	{
		return _sex==0;
	}
	
	/**
	 * @return
	 */
	public int getSex()
	{
		return _sex;
	}

	/**
	 * @param sex
	 */
	public void setSex(int sex)
	{
		_sex = sex;
	}

	/**
	 * @return
	 */
	public int getWalkSpeed()
	{
		return _walkSpeed;
	}

	/**
	 * @param walkSpeed
	 */
	public void setWalkSpeed(int walkSpeed)
	{
		_walkSpeed = walkSpeed;
	}
	
	/**
	 * if the target is canceld, also the attack is canceld
	 * @param i
	 */
	public void setTarget(L2Object object)
	{
		if (object == null && isInCombat())
		{
			setInCombat(false);
		}
		
		_target = object;
	}

	/**
	 * @return
	 */
	public int getTargetId()
	{
		if (_target != null)
		{
			return _target.getObjectId();
		}
		return -1;
	}
	
	public L2Object getTarget()
	{
		return _target;
	}
	
	/**
	 * @return Returns the currentState.
	 */
	public int getCurrentState()
	{
		return _currentState;
	}

	
	/**
	 * @param currentState The currentState to set.
	 */
	public void setCurrentState(int currentState)
	{
		_currentState = currentState;
	}

	/**
	 * @return Returns the zOffset.
	 */
	public double getCollisionHeight()
	{
		return _collisionHeight;
	}

	/**
	 * @param offset The zOffset to set.
	 */
	public void setCollisionHeight(double offset)
	{
		_collisionHeight = offset;
	}

	
	
	/**
	 * @return Returns the collisionRadius.
	 */
	public double getCollisionRadius()
	{
		return _collisionRadius;
	}

	/**
	 * @param collisionRadius The collisionRadius to set.
	 */
	public void setCollisionRadius(double collisionRadius)
	{
		_collisionRadius = collisionRadius;
	}

	/**
	 * @return Returns the unknown1.
	 */
	public double getUnknown1()
	{
		return _unknown1;
	}

	/**
	 * @param unknown1 The unknown1 to set.
	 */
	public void setUnknown1(double unknown1)
	{
		_unknown1 = unknown1;
	}

	/**
	 * @return Returns the unknown2.
	 */
	public double getUnknown2()
	{
		return _unknown2;
	}

	/**
	 * @param unknown2 The unknown2 to set.
	 */
	public void setUnknown2(double unknown2)
	{
		_unknown2 = unknown2;
	}

	protected String title;
	/**
		 * @return
		 */
	public String getTitle()
	{
		return title;
	}

	/**
		 * @param clanName
		 */
	public void setTitle(String title)
	{
		this.title = title;
	}

	/**
	 * @return Returns the runSpeed.
	 */
	public int getRunSpeed()
	{
		return _runSpeed;
	}
	/**
	 * @param runSpeed The runSpeed to set.
	 */
	public void setRunSpeed(int runSpeed)
	{
		_runSpeed = runSpeed;
	}

	private boolean _running;
	private int _flyingRunSpeed;
	private int _floatingWalkSpeed;
	private int _flyingWalkSpeed;
	private int _floatingRunSpeed;
	private int _activeSoulShotGrade;

	/**
	 * @return
	 */
	public boolean isRunning()
	{
		return _running;
	}

	/**
	 * @param b
	 */
	public void setRunning(boolean b)
	{
		_running = b;
	}

	/**
	 * @return
	 */
	public int getFloatingRunSpeed()
	{
		return _floatingRunSpeed;
	}

	/**
	 * @return
	 */
	public int getFloatingWalkSpeed()
	{
		return _floatingWalkSpeed;
	}

	/**
	 * @return
	 */
	public int getFlyingRunSpeed()
	{
		return _flyingRunSpeed;
	}

	/**
	 * @return
	 */
	public int getFlyingWalkSpeed()
	{
		return _flyingWalkSpeed;
	}
	/**
	 * @param floatingRunSpeed The floatingRunSpeed to set.
	 */
	public void setFloatingRunSpeed(int floatingRunSpeed)
	{
		_floatingRunSpeed = floatingRunSpeed;
	}
	/**
	 * @param floatingWalkSpeed The floatingWalkSpeed to set.
	 */
	public void setFloatingWalkSpeed(int floatingWalkSpeed)
	{
		_floatingWalkSpeed = floatingWalkSpeed;
	}
	/**
	 * @param flyingRunSpeed The flyingRunSpeed to set.
	 */
	public void setFlyingRunSpeed(int flyingRunSpeed)
	{
		_flyingRunSpeed = flyingRunSpeed;
	}
	/**
	 * @param flyingWalkSpeed The flyingWalkSpeed to set.
	 */
	public void setFlyingWalkSpeed(int flyingWalkSpeed)
	{
		_flyingWalkSpeed = flyingWalkSpeed;
	}

	/**
	 * @param i
	 */
	public void reduceCurrentMp(int i)
	{
		synchronized(_mpLock)
		{
			_currentMp -= i;
			if (!_mpRegenActive && !isDead())
			{
				startMpRegeneration();
			}
		}
		
		broadcastStatusUpdate();
	}

	/**
	 * @param i
	 */
	public void reduceCurrentHp(int i, L2Character attacker)
	{
		synchronized(_hpLock)
		{
			_currentHp -= i;
			
			if (_currentHp <= 0)
			{
				_log.fine("char is dead.");
				_currentHp = 0;
				
				stopHpRegeneration();
				stopMpRegeneration();
				
				if (_currentAttackTask != null)
				{
					_currentAttackTask.cancel();
				}
				
				if (_currentHitTask != null)
				{
					_currentHitTask.cancel();
				}
				
				if (_currentMoveTask != null)
				{
					_currentMoveTask.cancel();
				}
				
				StopMove stop = new StopMove(this);
				Die die = new Die(this);
				broadcastPacket(stop);
				sendPacket(stop);
				broadcastPacket(die);
				sendPacket(die);
			}
			else if (!_hpRegenActive)
			{
				startHpRegeneration();
			}
		}
		
		broadcastStatusUpdate();
	}
	
	public void moveTo(int x, int y, int z, int offset)
	{
		_moveOffset = offset;

		double distance = calculateMovement(x, y, z);

		if (distance> 0)
		{
			if (offset == 0)
			{
				_log.fine("moveToLoc: x:"+x+" y:"+y + " from x:"+ getX() + " y:" + getY()+ " z:" + getZ());
				CharMoveToLocation mov = new CharMoveToLocation(this);
				broadcastPacket(mov);
				sendPacket(mov);
			}
			else
			{
				_log.fine("moveToPawn: x:"+x+" y:"+y + " from x:"+ getX() + " y:" + getY() + " z:" + getZ());
				MoveToPawn mov = new MoveToPawn(this, getTarget(), offset);
				
				setMovingToPawn(true);
				setPawnTarget(getTarget());
				setPawnOffset(offset);
				
				broadcastPacket(mov);
				sendPacket(mov);

				if (getTarget() instanceof L2PcInstance)
				{
					_moveToPawn = (L2PcInstance)getTarget(); 
					_moveToPawn.addPositionListener(this);
				}
			}
		}
		else
		{
			sendPacket(new ActionFailed());
			// we are already at destination
			onTargetReached();
			return;
		}
	}
	
	public void updateMoveTo(int x, int y, int z)
	{
		double distance = calculateMovement(x, y, z);

		if (distance<= 0)
		{
			// we are already at destination
			onTargetReached();
			return;
		}
//		else //  this is here to verify the notify code
//		{
//			_log.fine("update toLoc");
//			CharMoveToLocation mov = new CharMoveToLocation(this);
//			broadcastPacket(mov);
//			sendPacket(mov);
//		}
	}
	
	/**
	 * @param x
	 * @param y
	 * @return
	 */
	private synchronized double calculateMovement(int x, int y, int z)
	{
		if (isMoving())
		{
			_log.fine("current movement interrupted .. setting new target");
			stopMove();
		}

		double distance = getDistance(x, y);
		_log.fine("distance to target:" + distance);
		
		int dx = x-getX();
		int dy = y-getY();
		
		if (_moveOffset >0)
		{
			if (distance - _moveOffset  <= 0)
			{
				distance = 0;
				_log.fine("already in range, no movement needed.");
			}
			else
			{
				distance -= (_moveOffset-5); // due to rounding error, we have to move a bit closer to be in range 
			}
			
			double angle = Math.atan2(-dy, -dx);
			dy = (int) -(Math.sin(angle) * distance);
			dx = (int) -(Math.cos(angle) * distance);
		}
		

		if (distance > 0)
		{
			int speed = 0;
			if (isRunning())
			{
				speed = getRunSpeed();
			}
			else
			{
				speed = getWalkSpeed();
			}
	
			// workaround to prevent divide by zero
			if (speed == 0)
			{
				_log.warning("speed is 0 for Character oid:"+getObjectId()+"using fallback");
				speed = 126;
			}
			
//			_log.fine("dx "+dx+" dy "+dy);
			_timeToTarget = (long) (distance * 1000 / speed);
			_xAddition = (dx/distance*speed)/1000;
			_yAddition = (dy/distance*speed)/1000;
			int heading = (int) (Math.atan2(-dy, -dx) * 10430.378350470452724949566316381);
			heading += 32768;
			setHeading(heading);
			_log.fine("dist:"+ distance +"speed:" + speed + " ttt:" +_timeToTarget + " dx:"+_xAddition + " dy:"+_yAddition + " heading:" + heading);
			int destinationX = getX() + (int) (_xAddition * _timeToTarget);
			int destinationY = getY() + (int) (_yAddition * _timeToTarget);
			setXdestination(destinationX);
			setYdestination(destinationY);
			setZdestination(z); // this is what was requested from client
//			_log.fine("destination: x "+destinationX+" y "+destinationY);

			_moveStartTime = System.currentTimeMillis();
			if (_timeToTarget < 0 )
			{
				_timeToTarget = 0;
			}
			
			_log.fine("time to target:" + _timeToTarget);
			ArriveTask newMoveTask = new ArriveTask(this);
			_currentMoveTask = newMoveTask;
			_moveTimer.schedule(newMoveTask, _timeToTarget);
			setIsMoving(true);
		}
		
		return distance;
	}

	/**
	 * 
	 */
	protected void stopHitTask()
	{
		if (_currentHitTask != null)
		{
			_currentHitTask.cancel();
			_currentHitTask = null;
		}
	}

	/**
	 * 
	 */
	protected void stopAttackTask()
	{
		if (_currentAttackTask != null)
		{
			_currentAttackTask.cancel();
			_currentAttackTask = null;
		}
	}

	/**
	 * @param b
	 */
	public void setIsMoving(boolean b)
	{
		_moving = b;
	}

	/**
	 * @param x   target x
	 * @param y   target y
	 * @return
	 */
	public double getDistance(int x, int y) 
	{
		long dx = x-getX();
		long dy = y-getY();
		double distance = Math.sqrt(dx*dx + dy*dy);
		return distance;
	}

	public L2Character[] broadcastPacket(ServerBasePacket mov)
	{
		Set list = getKnownPlayers();
		L2Character[] players = (L2Character[]) list.toArray(new L2Character[list.size()]);
		_log.fine("players to notify:" + players.length + " packet:"+mov.getType());
		
		for (int i=0; i < players.length; i++)
		{
			players[i].sendPacket(mov);
		}
		
		return players;
	}
	
	public void sendPacket(ServerBasePacket mov)
	{
		// default implementation
	}
	
	/**
	 * event that is called when the destination coordinates are reached
	 */
	public void onTargetReached()
	{
		_currentMoveTask = null;
		// update x,y,z with the current calculated position 
		stopMove();
		_log.fine("target reached at: x "+getX()+" y "+getY()+ " z:" + getZ());
		
		if (_moveToPawn != null)
		{
			_moveToPawn.removePositionListener(this);
			_moveToPawn = null;
			setMovingToPawn(false);
		}
	}

	public void setTo(int x, int y, int z, int heading)
	{
		setX(x);
		setY(y);
		setZ(z);
		setHeading(heading);
		if (isMoving())
		{	
			setCurrentState(STATE_IDLE);
			StopMove setto = new StopMove(this);
			broadcastPacket(setto);
		}
		else
		{
			SetToLocation setto = new SetToLocation(this);
			broadcastPacket(setto);
		}	
	
		FinishRotation fr = new FinishRotation(this);
		broadcastPacket(fr);
	}

	/**
	 * @return
	 */
	public boolean isDead()
	{
		return _currentHp <= 0;
	}
	/**
	 * @return Returns the rnd.
	 */
	public static Random getRnd()
	{
		return _rnd;
	}


	protected void startCombat()
	{
		if (_currentAttackTask == null)
		{
			_currentAttackTask = new AttackTask(this);
			_attackTimer.schedule(_currentAttackTask, 0);
		}
		else
		{
			_log.warning("multiple attacks want to start in parallel. prevented.");
		}
	}
	
	/**
	 * 
	 */
	private void onAttackTimer()
	{
		_currentAttackTask = null;
		_log.fine("onAttack: state="+getCurrentState() + "  target="+getTargetId());
		L2Character target = (L2Character) getTarget();
		
		if (isDead() || target == null || target.isDead() || getCurrentState()!=STATE_ATTACKING)
		{
			// if we are dead or the target is dead, we stop the attack 
			_log.fine("attack stopped");
			setInCombat(false);
			setCurrentState(STATE_IDLE);
			ActionFailed af = new ActionFailed();
			sendPacket(af);
			return;
		}

		if (getCurrentState() == STATE_ATTACKING)
		{
			L2Weapon weaponItem = getActiveWeapon();
			if (weaponItem == null)
			{
				_log.warning("char has no weapon. attack has no effect");
				return;
			}
			
			double distance = getDistance(target.getX(), target.getY());
			if (distance > getAttackRange())
			{
				_log.fine("target moved out of attack range, we have to follow");
				moveTo(getTarget().getX(), getTarget().getY(), getTarget().getZ(), getAttackRange());
				return;
			}
			
			int baseDamage = weaponItem.getPDamage();
			int randomDamage = weaponItem.getRandomDamage();
			
			int damage = 0;
			boolean crit = false;
			
			int hitTarget = getRnd().nextInt(100);
			boolean miss = false; //(getAccuracy()< hitTarget);
			boolean soulShotUse = false;


			if (!miss)
			{
				int pDef = target.getPhysicalDefense();
				if (pDef == 0)
				{
					pDef = 300;
					if (target instanceof L2NpcInstance)
					{
						_log.warning("target has bogus stats. check npc2.csv: id " + ((L2NpcInstance)target).getNpcTemplate().getNpcId());
					}
					else
					{
						_log.warning("target has bogus stats. Pdef was 0. temporary increased to 300");
					}
				}
				damage = (baseDamage + getRnd().nextInt(randomDamage)) * 70 / pDef ;
				
				int critHit = getRnd().nextInt(100);
				crit = (getCriticalHit() > critHit);
				
				if (crit)
				{
					damage *= 2;
				}
				
				// additional check to prevent users from activating low grade SS 
				// and switch weapon before attack
				if (getActiveSoulshotGrade() == weaponItem.getCrystalType())
				{
					soulShotUse = true;
					damage *= 2;
				}
			}
			
			Attack attack = new Attack(getObjectId(), getTargetId(), damage, miss, crit, soulShotUse, getX(), getY(), getZ() );
			setActiveSoulshotGrade(0);
			
			broadcastPacket(attack);  // send to all players
			sendPacket(attack);       // send also to attackers client
			
			if (!isInCombat() && !miss )
			{
				setInCombat(true);
			}
			
			//FIXME the attack time delay is fixed now. it should depend on the weapon and so on 
			_hitTimer.schedule(new HitTask(this, target, (int)damage, crit, miss, false), 700);
		}
	}

	/**
	 * @return
	 */
	public abstract L2Weapon getActiveWeapon();

	protected void onHitTimer(L2Character target, int damage, boolean crit, boolean miss, boolean soulshot)
	{
		if (!miss)
		{
			target.reduceCurrentHp(damage, this);
		}
		
		if (target.isDead())
		{
			setInCombat(false);
			setTarget(null);
			return;
		}
		else
		{
			_attackTimer.schedule(new AttackTask(this), 1000);
		}
	}

	public int getAttackRange()
	{
		return -1;
	}
	
	
	

	/**
	 * @return Returns the inCombat.
	 */
	public boolean isInCombat()
	{
		return _inCombat;
	}

	/**
	 * @param inCombat The inCombat to set.
	 */
	public void setInCombat(boolean inCombat)
	{
		if (inCombat)
		{
			sendPacket( new AutoAttackStart(getObjectId()));
			broadcastPacket(new AutoAttackStart(getObjectId()));
		}
		else
		{
			stopAttackTask();
			stopHitTask();
			
			sendPacket( new AutoAttackStop(getObjectId()));
			broadcastPacket(new AutoAttackStop(getObjectId()));
		}

		_inCombat = inCombat;
	}

	public void startAttack(L2Character target)
	{
		if (target.equals(getTarget()) && isInCombat())
		{
			_log.fine("attacking that target already.");
			return;
		}
		
		setTarget(target);

		setCurrentState(L2Character.STATE_ATTACKING);
		moveTo(target.getX(), target.getY(), target.getZ(), getAttackRange()); // melee range
	}
	
	
	public void onForcedAttack(L2PcInstance player)
	{
		player.startAttack(this);
	}
	
	public int getActiveSoulshotGrade()
	{
		return _activeSoulShotGrade;
	}
	
	public void setActiveSoulshotGrade(int soulshotGrade)
	{
		_activeSoulShotGrade = soulshotGrade;
	}
	
	
	public void setMovingToPawn(boolean val)
	{
		_movingToPawn = val;
	}
	
	public void setPawnTarget(L2Object target)
	{
		_pawnTarget = target;
	}
	
	public void setPawnOffset(int offset)
	{
		_pawnOffset = offset;
	}
	
	public boolean isMovingToPawn()
	{
		return _movingToPawn;
	}
	
	public L2Object getPawnTarget()
	{
		return _pawnTarget;
	}
	
	public int getPawnOffset()
	{
		return _pawnOffset;
	}
	
}	
