/*
 * $Header: /var/lib/gforge/chroot/cvsroot/nextg/CVSROOT/L2_Gameserver/java/net/sf/l2j/gameserver/model/L2Object.java,v 1.3 2004/08/05 00:53:40 nextg Exp $
 *
 * $Author: nextg $
 * $Date: 2004/08/05 00:53:40 $
 * $Revision: 1.3 $
 * $Log: L2Object.java,v $
 * Revision 1.3  2004/08/05 00:53:40  nextg
 * RuSh
 *
 * Revision 1.9  2004/08/02 00:08:13  l2chef
 * attempt to fix concurrent modification
 *
 * Revision 1.8  2004/07/28 23:59:33  l2chef
 * knowPlayers is now a Set to prevent duplicates
 *
 * Revision 1.7  2004/07/23 01:48:11  l2chef
 * knownobject handling is moved here
 *
 * Revision 1.6  2004/07/19 02:07:19  l2chef
 * default action handler return now action failed to prevent client freeze
 *
 * Revision 1.5  2004/07/17 23:04:40  l2chef
 * added default method for forced attack
 *
 * Revision 1.4  2004/07/13 22:55:52  l2chef
 * empty blocks commented
 *
 * Revision 1.3  2004/07/11 22:13:20  l2chef
 * removed task
 *
 * Revision 1.2  2004/06/27 08:51:42  jeichhorn
 * Added copyright notice
 *
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 *
 * http://www.gnu.org/copyleft/gpl.html
 */
package net.sf.l2j.gameserver.model;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.Collections;
import java.util.HashSet;
import java.util.List;
import java.util.Set;

import net.sf.l2j.gameserver.serverpackets.ActionFailed;

/**
 * This class ...
 * 
 * @version $Revision: 1.3 $ $Date: 2004/08/05 00:53:40 $
 */
public class L2Object implements Serializable
{
	private int _objectId;
	// this is for items/chars that have are seen in the world
	private int _x;
	private int _y;
	private int _z;

	// FIXME a quick solution to prevent concurrent modification problems, but it might cause lag
	protected List _knownObjects = Collections.synchronizedList(new ArrayList());


	/**
	 * @return
	 */
	public int getObjectId()
	{
		return _objectId;
	}

	/**
	 * @param objectId
	 */
	public void setObjectId(int objectId)
	{
		_objectId = objectId;
	}

	/**
	 * @return Returns the x.
	 */
	public int getX()
	{
		return _x;
	}

	/**
	 * @param x The x to set.
	 */
	public void setX(int x)
	{
		_x = x;
	}

	/**
	 * @return Returns the y.
	 */
	public int getY()
	{
		return _y;
	}

	/**
	 * @param y The y to set.
	 */
	public void setY(int y)
	{
		_y = y;
	}

	/**
	 * @return Returns the z.
	 */
	public int getZ()
	{
		return _z;
	}

	/**
	 * @param z The z to set.
	 */
	public void setZ(int z)
	{
		_z = z;
	}

	/**
	 * @param activeChar
	 */
	public void onAction(L2PcInstance player)
	{
		player.sendPacket(new ActionFailed());
	}

	/**
	 * @param player
	 */
	public void onActionShift(L2PcInstance player)
	{
		player.sendPacket(new ActionFailed());
	}
	
	public void onForcedAttack(L2PcInstance player)
	{
		player.sendPacket(new ActionFailed());
	}

	public List getKnownObjects()
	{
		return _knownObjects;
	}

	public void addKnownObject(L2Object object)
	{
		_knownObjects.add(object);
		if (object instanceof L2PcInstance)
		{
			_knownPlayer.add(object);
		}
	}

	public void removeKnownObject(L2Object object)
	{
		_knownObjects.remove(object);
		if (object instanceof L2PcInstance)
		{
			_knownPlayer.remove(object);
		}
	}

	public void removeAllKnownObjects()
	{
		L2Object[] notifyList = (L2Object[]) _knownObjects.toArray(new L2Object[_knownObjects.size()]);
		// clear our own list
		_knownObjects.clear();
		
		for (int i = 0; i < notifyList.length; i++)
		{
			if (notifyList[i] instanceof L2Character)
			{
				((L2Character)notifyList[i]).removeKnownObject(this);
			}
		}
	}

	private Set _knownPlayer = new HashSet();

	public Set getKnownPlayers()
	{
		return _knownPlayer;
	}
}
