/*
 * $Header: /var/lib/gforge/chroot/cvsroot/nextg/CVSROOT/L2_Gameserver/java/net/sf/l2j/gameserver/serverpackets/SkillList.java,v 1.3 2004/08/05 00:53:40 nextg Exp $
 *
 * $Author: nextg $
 * $Date: 2004/08/05 00:53:40 $
 * $Revision: 1.3 $
 * $Log: SkillList.java,v $
 * Revision 1.3  2004/08/05 00:53:40  nextg
 * RuSh
 *
 * Revision 1.3  2004/07/04 11:14:53  l2chef
 * logging is used instead of system.out
 *
 * Revision 1.2  2004/06/27 08:51:42  jeichhorn
 * Added copyright notice
 *
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 *
 * http://www.gnu.org/copyleft/gpl.html
 */
package net.sf.l2j.gameserver.serverpackets;

import java.util.Vector;

/**
 * 
 *
 * sample 
 * 0000: 6d 0c 00 00 00 00 00 00 00 03 00 00 00 f3 03 00    m...............
 * 0010: 00 00 00 00 00 01 00 00 00 f4 03 00 00 00 00 00    ................
 * 0020: 00 01 00 00 00 10 04 00 00 00 00 00 00 01 00 00    ................
 * 0030: 00 2c 04 00 00 00 00 00 00 03 00 00 00 99 04 00    .,..............
 * 0040: 00 00 00 00 00 02 00 00 00 a0 04 00 00 00 00 00    ................
 * 0050: 00 01 00 00 00 c0 04 00 00 01 00 00 00 01 00 00    ................
 * 0060: 00 76 00 00 00 01 00 00 00 01 00 00 00 a3 00 00    .v..............
 * 0070: 00 01 00 00 00 01 00 00 00 c2 00 00 00 01 00 00    ................
 * 0080: 00 01 00 00 00 d6 00 00 00 01 00 00 00 01 00 00    ................
 * 0090: 00 f4 00 00 00
 * 
 * format   d (ddd)
 * 
 * @version $Revision: 1.3 $ $Date: 2004/08/05 00:53:40 $
 */
public class SkillList extends ServerBasePacket
{
	private static final String _S__6D_SKILLLIST = "[S] 6D SkillList";
	private Vector _skills;
	
	class Skill
	{
		public int id;
		public int level;
		public boolean passive;
		
		Skill(int id, int level, boolean passive)
		{
			this.id = id;
			this.level = level;
			this.passive = passive;
		}
	}

	public SkillList()
	{
		_skills = new Vector();
	}	
	
	public void addSkill(int id, int level, boolean passive)
	{
		_skills.add(new Skill(id,level,passive));
	}
	
	public byte[] getContent()
	{
		writeC(0x6d);
		writeD(_skills.size());

		for (int i = 0; i < _skills.size(); i++)
		{
			Skill temp = (Skill) _skills.get(i);
			if (temp.passive)
			{
				writeD(0x01);
			}
			else
			{
				writeD(0x00);
			}
			
			writeD(temp.level);			
			writeD(temp.id);
		}

		return getBytes();
	}

	/* (non-Javadoc)
	 * @see net.sf.l2j.gameserver.serverpackets.ServerBasePacket#getType()
	 */
	public String getType()
	{
		return _S__6D_SKILLLIST;
	}
}
